# Nextcloud News Android Privacy Policy

The "Nextcloud News" Android-App (in the following referred to as "App") does not collect or send any data from you or your device to a server of the developers or the [Nextcloud GmbH](https://nextcloud.com/). The App sends all data exclusively to the server configured by you with the intention to synchronize the contents of the App with those of the server. This data can contain IP-addresses, timestamps and further information as meta data.
It is important to mention that all contents of the App may also be transmitted to the configured server. This contents can also contain personal information depending on the use. The servers you configured are technically outside the access area of this App developers, so that we neither know nor can prevent what happens to your data there. Please consult the privacy policy of the respective server operator.

----------

Cookies are files with a small amount of data that are commonly used as anonymous unique identifiers. These are sent to your browser from the websites that you visit and are stored on your device's internal memory.

This App does not use these “cookies” explicitly. However, some websites that provide RSS feeds might use “cookies” to collect information to improve their services.
The feeds that the user subscribes to have their own consent dialogs so that users of this app can either accept or refuse these cookies on a per-feed basis.
If users do not want any feeds to track them, they can enable the so called "Incognito Mode" inside the app which will block all tracking methods from feeds (no cookies / no tracking-images).

----------

In order to use this app, users need to host a Nextcloud Server themselves. On this server they can subscribe to any RSS Feeds they want to.

## Permissions

This is a list of permissions required and asked by the App in order to properly work on your device:

- `android.permission.ACCESS_FINE_LOCATION`

  Used to automatically switch between light / dark theme

- `android.permission.INTERNET`

  Used by [Nextcloud Single Sign On library](https://github.com/nextcloud/Android-SingleSignOn/) to communicate with your Nextcloud instance and synchronize contents.

- `android.permission.ACCESS_NETWORK_STATE`

  Used to provide offline support and make the "Sync only on Wi-Fi" option possible.

- `android.permission.WRITE_EXTERNAL_STORAGE`

  Used for caching purposes / offline reading / storing podcasts

- `android.permission.INTERNET`

  Used by [Nextcloud Single Sign On library](https://github.com/nextcloud/Android-SingleSignOn/) to communicate with your Nextcloud instance and synchronize contents.

- `android.permission.GET_ACCOUNTS`

  Used by [Nextcloud Single Sign On library](https://github.com/nextcloud/Android-SingleSignOn/) to read available accounts to import.

- `android.permission.READ_SYNC_SETTINGS`

  Used for background synchronization.

- `android.permission.WRITE_SYNC_SETTINGS`

  Used for background synchronization.

- `android.permission.WAKE_LOCK`

  Used for background synchronization.

- `android.permission.FOREGROUND_SERVICE`

  Used for background synchronization.



## Contact

- **David Luhmer**
- **E-Mail:** david-dev(at)live.de
- **Phone:** +49 2222 9770191


## Nextcloud privacy policy

You can get more information on Nextcloud general privacy policy which is accessible at [nextcloud.com/privacy](https://nextcloud.com/privacy/).
